﻿;#NoTrayIcon
;!+c::Menu, TRAY, Icon
#SingleInstance force

;クリップボードの履歴を取る。
OnClipboardChange:

   ClipWait, 1    ;ClipWaitがないとcan't open clipboard for reading エラーが出る。

   ;http:;ahk.xrea.jp/misc/Clipboard.html#OnClipboardChange
   ; 1テキスト（、2：非テキスト、0：空）
   if (A_EventInfo = 1)
   {   if ( new != clipboard)
       {   back := new
           new  := clipboard
       }
   }
return


#i::
    equal   := "="
    semiC   := "`;"
    comment := "//"
    GoSub, クリップボード準備

    ; 全行の中で、左辺、右辺の最大値を保持する
    spaceCount_EqualL := 0
    spaceCount_EqualR := 0

    ; 改行区切りでクリップボードの内容を読み込む。ループの中で左辺・右辺の最長の長さを求める
    Loop, Parse, clipboard, `n
    {   line := A_LoopField

        ; 左辺（「=」の左側）：修飾子と変数名
        lineArray := strSplit(line, equal)
        vname     := lineArray[1]
        ; 左辺の最長の長さを求める
        spaceCount_EqualL := max( spaceCount_EqualL, strLen(vname) )

        ; 「//」 が含まれる場合は、そこも垂直揃え
        IfInString, line, %comment%
        {
            ; 右辺 （「=」の右から「;」まで）：値
            value := strSplit(lineArray[2], semiC)[1] . "`;"
            ; 右辺の最長の長さを求める
            spaceCount_EqualR := max( spaceCount_EqualR, strLen(value) )
        }
    }

    replacedStr := ""
    ; 各行に対して、適切な分だけ半角スペースをright paddingする
    Loop, Parse, clipboard, `n
    {   line := A_LoopField

        ; 左辺
        lineArray := strSplit(A_LoopField, equal)
        vname     := lineArray[1]

        ; 左辺をright padding
        vname_rpad := rpad(vname, spaceCount_EqualL)
        line := strReplace(line, vname , vname_rpad)

        ; 「//」 が含まれる場合は、そこも垂直揃え
        IfInString, line, %comment%
        {   ; 右辺
            value := StrSplit(lineArray[2], semiC)[1] . "`;"

            ; 右辺をright padding
            value_rpad := rpad(value, spaceCount_EqualR)
            line := strReplace(line, value, value_rpad)
        }

        ; 置換後の文字列を組み立て
        replacedStr .=  line
    }

    ; 処理結果をペースト
    if replacedStr !=
    {   Clipboard := replacedStr
        ClipWait, 1
        Send, ^v
        GoSub, クリップボード後始末
    } else
    {   Clipboard := bk
        TTS("ClipboardError occurred.", 500)
        Exit
    }
return

; 指定した文字列になるまで、文字の右側に半角スペースを追加する
rpad(tmpStr, spaceCount){
    While strLen(tmpStr) < spaceCount
    {   tmpStr .= A_Space
    }
    return tmpStr
}
; 大きい方を返す
max(int1, int2){
    return int1 >  int2 ? int1 : int2
}


クリップボード準備:
   bk := ClipboardAll
   TTS("bk = %ClipboardAll%   complete")
   Clipboard =
   Send,^c
   ClipWait,1
   if ErrorLevel = 1
   {    Goto, クリップボードエラー処理
   }
   TTS("prepare complete")
return

クリップボード後始末:
   Clipboard = %bk%
   TTS("Run complete")
return

クリップボードエラー処理:
   TTS("ClipboardError. Thread will Exit",500)
   Clipboard = %bk%
Exit


return


TTS(message,time=2000,X=20,Y=30)	;ToolTipShow
{
	CoordMode, Mouse, Relative
	MouseGetPos,Caret_X,Caret_Y
	Caret_X += X
	Caret_Y += Y
	ToolTip,%message%,Caret_X,Caret_Y
	SetTimer,ToolTipDel,%time%
	sleep,30	;ToolTipが表示されるのを待ってから、透明化を行う。
	WinSet,Trans,150,ahk_class tooltips_class32
}

ToolTipDel:
	ToolTip
	SetTimer,ToolTipDel,off
return